<?php
if ( !defined( 'ABSPATH' ) ) {
	exit;
}

class FES_Menu {
	public function __construct() {
		add_action( 'admin_menu', array( $this, 'admin_menus' ), 9 );
	}

	public function admin_menus() {
		if ( EDD_FES()->vendors->user_is_admin() ){
			global $fes_settings;
			$welcome    = new FES_Welcome();
			$tools      = new FES_Tools();
			$minimum_capability = 'manage_shop_settings';
			add_menu_page(  __( 'EDD FES', 'edd_fes' ), __( 'EDD FES', 'edd_fes' ), $minimum_capability, 'fes-about', array( $welcome, 'load_page' ), '', '25.01' );
			add_submenu_page( 'fes-about', __( 'About', 'edd_fes' ), __( 'About', 'edd_fes' ), $minimum_capability, 'fes-about', array( $welcome, 'load_page' ) );
			add_submenu_page( 'fes-about', EDD_FES()->helper->get_vendor_constant_name( $plural = true, $uppercase = true ), EDD_FES()->helper->get_vendor_constant_name( $plural = true, $uppercase = true ), 'manage_shop_settings', 'fes-vendors', 'fes_vendors_page' );
			foreach ( EDD_FES()->load_forms as $name => $class ) {
				$form = new $class( $name, 'name' );
				if ( $form->has_formbuilder() && ! empty( $form->id ) ) {
					add_submenu_page( 'fes-about', $form->title( true ), $form->title( true ), 'manage_shop_settings', 'post.php?post=' . $form->id . '&action=edit' );
				}
			}
			add_submenu_page( 'fes-about', __( 'Tools', 'edd_fes' ), __( 'Tools', 'edd_fes' ), 'manage_shop_settings', 'fes-tools', array( $tools, 'fes_tools_page' ) );
		}
	}
}
