<?php
if ( !defined( 'ABSPATH' ) ) {
	exit;
}

/**
 * FES Form builder template
 * Warning: This class is a candidate for deprecation starting with 2.4
 */
class FES_Formbuilder_Templates {

	/**
	 * Legend of a form item
	 *
	 * @param string  $title
	 * @param array   $values
	 *
	 * Note: Deprecated since 2.3. Slated for removal in 2.4.
	 */
	public static function legend( $title = 'Field Name', $values = array(), $removable = true ) {
		_fes_deprecated_function( 'EDD_FES()->formbuilder_templates->legend', '2.3', 'FES_Field->legend' );
		$field_label = '';
		$legend      = '';
		if ( empty( $values['label'] ) && !empty( $values['class'] ) ) {
			$field       = new $values['class'];
			$title       = $field->supports['title'];
			$legend      = '<strong>'. $title . '</strong>';
		} else if ( !empty( $values['label'] ) && !empty( $values['class'] ) ) {
				$field_label = $values['label'];
				$field       = new $values['class'];
				$title       = $field->supports['title'];
				if ( $title === $field_label ) {
					$legend      = '<strong>' . $title  . '</strong>';
				}
				else {
					$legend      = '<strong>' . $title . '</strong>: '. $field_label;
				}
		} else {
			$field_label = $values && isset( $values['label'] ) ? $values['label'] : '';
			$title       = $title;
			if ( $title === $field_label ) {
				$legend      = '<strong>' . $title  . '</strong>';
			}
			else {
				$legend      = '<strong>' . $title . '</strong>: '. $field_label;
			}
		} ?>
		<div class="fes-legend" title="<?php _e( 'Click and Drag to rearrange', 'edd_fes' ); ?>">
			<div class="fes-label"><?php echo $legend; ?></div>
			<div class="fes-actions">
				<?php if ( $removable ) { ?>
				<a href="#" class="fes-remove"><?php _e( 'Remove', 'edd_fes' ); ?></a>
				<?php } ?>
				<a href="#" class="fes-toggle"><?php _e( 'Toggle', 'edd_fes' ); ?></a>
			</div>
		</div> <!-- .fes-legend -->
		<?php
	}

	/**
	 * Common Fields for a input field
	 *
	 * Contains required, label, meta_key, help text, css class name
	 *
	 * @param int     $id               field order
	 * @param mixed   $field_name_value
	 * @param bool    $custom_field     if it a custom field or not
	 * @param array   $values           saved value
	 *
	 * Note: Deprecated since 2.3. Slated for removal in 2.4.
	 */
	public static function common( $id, $field_name_value = '', $custom_field = true, $values = array(), $force_required = false, $template = 'text' ) {
		_fes_deprecated_function( 'EDD_FES()->formbuilder_templates->common', '2.3', 'EDD_FES()->formbuilder_templates->standard' );
		$tpl = '%s[%d][%s]';
		$required_name = sprintf( $tpl, 'fes_input', $id, 'required' );
		$field_name    = sprintf( $tpl, 'fes_input', $id, 'name' );
		$label_name    = sprintf( $tpl, 'fes_input', $id, 'label' );
		$help_name     = sprintf( $tpl, 'fes_input', $id, 'help' );
		$css_name      = sprintf( $tpl, 'fes_input', $id, 'css' );

		$required_from_bool = isset( $values['required'] ) ? $values['required'] : 'yes';
		if ( $required_from_bool !== 'yes' && $required_from_bool !== 'no' ) {
			$required_from_bool = $values['required'] ? 'yes' : 'no';
		}

		$required           = isset( $values['required'] ) ? esc_attr( $required_from_bool ) : 'yes';
		$template           = !empty( $values['template'] ) ? $values['template'] : $template;
		$label_value        = isset( $values['label'] ) && ! empty( $values['label'] ) ? esc_attr( $values['label'] ) : esc_attr( ucwords( str_replace( '_', ' ', $template ) ) );
		$help_value         = isset( $values['help'] )? esc_textarea( $values['help'] ) : '';
		$css_value          = isset( $values['css'] )? esc_attr( $values['css'] ) : '';
		$meta_type          = "yes"; // for post meta on custom fields

		if ( $custom_field && $values ) {
			$field_name_value = trim( $values[ 'name' ] );
		}

		$exclude = array( 'email_to_use_for_contact_form', 'name_of_store' );
		if ( $custom_field && in_array( $field_name_value, $exclude ) ) {
			$custom_field = false;
		}

		do_action( 'fes_add_field_to_common_form_element', $tpl, 'fes_input', $id, $values ); ?>

		<div class="fes-form-rows required-field">
			<?php if ( !$force_required ) { ?>
				<label> <?php if ( !$force_required ) { ?><?php _e( 'Required', 'edd_fes' ); ?><?php } ?></label>
				<div class="fes-form-sub-fields">
					<input type="radio" name="<?php echo $required_name; ?>" <?php checked( $required, 'yes' ); ?>> <?php _e( 'Yes', 'edd_fes' ); ?>
					<input type="radio" name="<?php echo $required_name; ?>" <?php checked( $required, 'no' ); ?>> <?php _e( 'No', 'edd_fes' ); ?>
				</div>
			<?php } else { ?>
				<input type="hidden" name="<?php echo $required_name; ?>" value="yes" checked />
			<?php } ?>
		</div>

		<div class="fes-form-rows">
			<label><?php _e( 'Field Label', 'edd_fes' ); ?></label>
			<input type="text" data-type="label" name="<?php echo $label_name; ?>" value="<?php echo $label_value; ?>" class="smallipopInput" title="<?php _e( 'Enter a title of this field', 'edd_fes' ); ?>">
		</div>

		<?php if ( $custom_field ) { ?>
			<div class="fes-form-rows">
				<label><?php _e( 'Meta Key', 'edd_fes' ); ?></label>
				<input type="text" name="<?php echo $field_name; ?>" value="<?php echo trim( $field_name_value );?>" data-type="metakey" class="smallipopInput" title="<?php _e( 'Name of the meta key this field will save to', 'edd_fes' ); ?>">
			</div>
		<?php } else { ?>
			<input type="hidden" name="<?php echo $field_name; ?>" value="<?php echo trim( $field_name_value ); ?>">
		<?php } ?>

		<div class="fes-form-rows">
			<label><?php _e( 'Help text', 'edd_fes' ); ?></label>
			<textarea name="<?php echo $help_name; ?>" class="smallipopInput" title="<?php _e( 'Give the user some information about this field', 'edd_fes' ); ?>"><?php echo $help_value; ?></textarea>
		</div>
		<?php if ( !isset( $values['no_css'] ) || !$values['no_css'] ) { ?>
		<div class="fes-form-rows">
			<label><?php _e( 'CSS Class Name', 'edd_fes' ); ?></label>
			<input type="text" name="<?php echo $css_name; ?>" value="<?php echo $css_value; ?>" class="smallipopInput" title="<?php _e( 'Add a CSS class name for this field', 'edd_fes' ); ?>">
		</div>
		<?php } ?>
		<?php
	}

	/**
	 * Common Fields for a input field
	 *
	 * Contains required, label, meta_key, help text, css class name
	 *
	 * @since 2.3.0
	 *
	 * @param int     $id    field order
	 * @param object  $field An FES Field object
	 */
	public static function standard( $index, $field ) {
		// this is a quick port from the old common function. We'll clean this function up in 2.4
		$field_name_value = $field->name();
		$custom_field     = $field->supports['position'] == 'custom';
		$values           = $field->characteristics;
		$required         = isset( $field->supports['permissions']['can_remove_from_formbuilder'] ) ? $field->supports['permissions']['can_remove_from_formbuilder'] : true;
		$force_required   = isset( $field->supports['permissions']['field_always_required'] ) ? $field->supports['permissions']['field_always_required'] : false;
		$template         = $field->characteristics['template'];
		$tpl              = '%s[%d][%s]';
		$required_name    = sprintf( $tpl, 'fes_input', $index, 'required' );
		$field_name       = sprintf( $tpl, 'fes_input', $index, 'name' );
		$label_name       = sprintf( $tpl, 'fes_input', $index, 'label' );
		$help_name        = sprintf( $tpl, 'fes_input', $index, 'help' );
		$css_name         = sprintf( $tpl, 'fes_input', $index, 'css' );

		if ( $force_required ) {
			$required = true;
		} else {
			// if saved field before
			if (  isset( $values['required'] ) ) {
				if (  $values['required'] === 'yes' ) {
					$required = true;
				} else {
					$required = false;
				}
			} else {
				// no change
			}
		}

		if ( $required ) {
			$required = 'yes';
		} else {
			$required = 'no';
		}

		$template           = !empty( $values['template'] ) ? $values['template'] : $template;
		$label_value        = isset( $values['label'] ) && ! empty( $values['label'] ) ? esc_attr( $values['label'] ) : esc_attr( ucwords( str_replace( '_', ' ', $template ) ) );
		$help_value         = isset( $values['help'] )? esc_textarea( $values['help'] ) : '';
		$css_value          = isset( $values['css'] )? esc_attr( $values['css'] ) : '';
		$meta_type          = "yes"; // for post meta on custom fields

		$exclude = array( 'email_to_use_for_contact_form', 'name_of_store', 'recaptcha' );
		if ( $custom_field && in_array( $field_name_value, $exclude ) ) {
			$custom_field = false;
		}

		do_action( 'fes_add_field_to_common_form_element', $tpl, 'fes_input', $index, $values ); ?>

		<div class="fes-form-rows required-field">
			<?php if ( !$force_required ) { ?>
				<label><?php _e( 'Required', 'edd_fes' ); ?></label>
				<div class="fes-form-sub-fields">
					<input type="radio" name="<?php echo $required_name; ?>" value="yes" <?php checked( $required, 'yes' ); ?>> <?php _e( 'Yes', 'edd_fes' ); ?>
					<input type="radio" name="<?php echo $required_name; ?>" value="no" <?php checked( $required, 'no' ); ?>> <?php _e( 'No', 'edd_fes' ); ?>
				</div>
			<?php } else { ?>
				<input type="hidden" name="<?php echo $required_name; ?>" value="yes" checked />
			<?php } ?>
		</div>

		<div class="fes-form-rows">
			<label><?php _e( 'Field Label', 'edd_fes' ); ?></label>
			<input type="text" data-type="label" name="<?php echo $label_name; ?>" value="<?php echo $label_value; ?>" class="smallipopInput" title="<?php _e( 'Enter a title of this field', 'edd_fes' ); ?>">
		</div>

		<?php
		if ( $custom_field && ( isset( $field->supports['permissions']['can_change_meta_key'] ) && $field->supports['permissions']['can_change_meta_key'] ) !== false ) { ?>
			<div class="fes-form-rows">
				<label><?php _e( 'Meta Key', 'edd_fes' ); ?></label>
				<input type="text" name="<?php echo $field_name; ?>" value="<?php echo $field_name_value; ?>" data-type="metakey" class="smallipopInput" title="<?php _e( 'Name of the meta key this field will save to', 'edd_fes' ); ?>">
			</div>
		<?php } else { ?>
			<input type="hidden" name="<?php echo $field_name; ?>" value="<?php echo $field_name_value; ?>">
		<?php } ?>

		<div class="fes-form-rows">
			<label><?php _e( 'Help text', 'edd_fes' ); ?></label>
			<textarea name="<?php echo $help_name; ?>" class="smallipopInput" title="<?php _e( 'Give the user some information about this field', 'edd_fes' ); ?>"><?php echo $help_value; ?></textarea>
		</div>
		<?php if ( !isset( $values['no_css'] ) || !$values['no_css'] ) { ?>
		<div class="fes-form-rows">
			<label><?php _e( 'CSS Class Name', 'edd_fes' ); ?></label>
			<input type="text" name="<?php echo $css_name; ?>" value="<?php echo $css_value; ?>" class="smallipopInput" title="<?php _e( 'Add a CSS class name for this field', 'edd_fes' ); ?>">
		</div>
		<?php } ?>
		<?php
	}


	/**
	 * Common fields for a text area
	 *
	 * @param int     $id
	 * @param array   $values
	 */
	public static function common_text( $id, $values = array() ) {
		$tpl = '%s[%d][%s]';
		$placeholder_name = sprintf( $tpl, 'fes_input', $id, 'placeholder' );
		$default_name = sprintf( $tpl, 'fes_input', $id, 'default' );
		$size_name = sprintf( $tpl, 'fes_input', $id, 'size' );

		$placeholder_value = $values && isset( $values['placeholder'] )? esc_attr( $values['placeholder'] ) : '';
		$default_value = $values && isset( $values['default'] ) ? esc_attr( $values['default'] ) : '';
		$size_value = $values && isset( $values['size'] ) ? esc_attr( $values['size'] ) : '40';
		$show_placeholder =  $values && empty( $values['show_placeholder'] ) ? false : true;
		$show_default_value =  $values && empty( $values['default_value'] ) ? false : true;

		if ( $show_placeholder ) { ?>
		<div class="fes-form-rows">
			<label><?php _e( 'Placeholder text', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $placeholder_name; ?>" title="<?php esc_attr_e( 'Text for HTML5 placeholder attribute', 'edd_fes' ); ?>" value="<?php echo $placeholder_value; ?>" />
		</div>
		<?php }
		if ( $show_default_value ) { ?>
		<div class="fes-form-rows">
			<label><?php _e( 'Default value', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $default_name; ?>" title="<?php esc_attr_e( 'The default value this field will have', 'edd_fes' ); ?>" value="<?php echo $default_value; ?>" />
		</div>
		<?php } ?>
		<div class="fes-form-rows">
			<label><?php _e( 'Size', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $size_name; ?>" title="<?php esc_attr_e( 'Size of this input field', 'edd_fes' ); ?>" value="<?php echo $size_value; ?>" />
		</div>
		<?php
	}

	/**
	 * Common fields for a textarea
	 *
	 * @param int     $id
	 * @param array   $values
	 */
	public static function common_textarea( $id, $values = array() ) {
		$tpl = '%s[%d][%s]';
		$rows_name = sprintf( $tpl, 'fes_input', $id, 'rows' );
		$cols_name = sprintf( $tpl, 'fes_input', $id, 'cols' );
		$rich_name = sprintf( $tpl, 'fes_input', $id, 'rich' );
		$placeholder_name = sprintf( $tpl, 'fes_input', $id, 'placeholder' );
		$default_name = sprintf( $tpl, 'fes_input', $id, 'default' );

		$rows_value = $values && ! empty( $values['rows'] )? esc_attr( $values['rows'] ) : '5';
		$cols_value = $values && ! empty( $values['cols'] )? esc_attr( $values['cols'] ) : '25';
		$rich_value = $values && ! empty( $values['rich'] )? esc_attr( $values['rich'] ) : 'no';
		$placeholder_value = $values && isset( $values['placeholder'] )? esc_attr( $values['placeholder'] ) : '';
		$default_value = $values && isset( $values['default'] )? esc_attr( $values['default'] ) : ''; ?>
		<div class="fes-form-rows">
			<label><?php _e( 'Rows', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $rows_name; ?>" title="Number of rows in textarea" value="<?php echo $rows_value; ?>" />
		</div>

		<div class="fes-form-rows">
			<label><?php _e( 'Columns', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $cols_name; ?>" title="Number of columns in textarea" value="<?php echo $cols_value; ?>" />
		</div>

		<div class="fes-form-rows">
			<label><?php _e( 'Placeholder text', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $placeholder_name; ?>" title="text for HTML5 placeholder attribute" value="<?php echo $placeholder_value; ?>" />
		</div>

		<div class="fes-form-rows">
			<label><?php _e( 'Default value', 'edd_fes' ); ?></label>
			<input type="text" class="smallipopInput" name="<?php echo $default_name; ?>" title="the default value this field will have" value="<?php echo $default_value; ?>" />
		</div>

		<div class="fes-form-rows">
			<label><?php _e( 'Textarea', 'edd_fes' ); ?></label>

			<div class="fes-form-sub-fields">
				<input type="radio" name="<?php echo $rich_name; ?>" value="no"<?php checked( $rich_value, 'no' ); ?>> <?php _e( 'Normal', 'edd_fes' ); ?>
				<input type="radio" name="<?php echo $rich_name; ?>" value="yes"<?php checked( $rich_value, 'yes' ); ?>> <?php _e( 'Rich textarea', 'edd_fes' ); ?>
				<input type="radio" name="<?php echo $rich_name; ?>" value="teeny"<?php checked( $rich_value, 'teeny' ); ?>> <?php _e( 'Teeny Rich textarea', 'edd_fes' ); ?>
			</div>
		</div>
		<?php
	}

	/**
	 * Hidden field helper function
	 *
	 * @param string  $name
	 * @param string  $value
	 */
	public static function hidden_field( $name, $value = '' ) {
		printf( '<input type="hidden" name="%s" value="%s" />', 'fes_input' . $name, $value );
	}

	/**
	 * Displays a radio custom field
	 *
	 * @param int     $field_id
	 * @param string  $name
	 * @param array   $values
	 */
	public static function radio_fields( $field_id, $name, $values = array() ) {
		$selected_name = sprintf( '%s[%d][selected]', 'fes_input', $field_id );
		$input_name = sprintf( '%s[%d][%s]', 'fes_input', $field_id, $name );

		$selected_value = ( $values && isset( $values['selected'] ) ) ? $values['selected'] : '';
		$add = fes_assets_url .'img/add.png';
		$remove = fes_assets_url. 'img/remove.png';

		if ( $values && $values['options'] > 0 ) {
			foreach ( $values['options'] as $key => $value ) { ?>
				<div>
					<input type="radio" name="<?php echo $selected_name ?>" value="<?php echo $value; ?>" <?php checked( $selected_value, $value ); ?>>
					<input type="text" name="<?php echo $input_name; ?>[]" value="<?php echo $value; ?>">
					<img style="cursor:pointer; margin:0 3px;" alt="add another choice" title="add another choice" class="fes-clone-field" src="<?php echo $add; ?>">
					<img style="cursor:pointer;" class="fes-remove-field" alt="remove this choice" title="remove this choice" src="<?php echo $remove; ?>">
				</div>
				<?php
			}
		} else { ?>
			<div>
				<input type="radio" name="<?php echo $selected_name ?>">
				<input type="text" name="<?php echo $input_name; ?>[]" value="">
				<img style="cursor:pointer; margin:0 3px;" alt="add another choice" title="add another choice" class="fes-clone-field" src="<?php echo $add; ?>">
				<img style="cursor:pointer;" class="fes-remove-field" alt="remove this choice" title="remove this choice" src="<?php echo $remove; ?>">
			</div>
		<?php
		}
	}

	/**
	 * Displays a checkbox custom field
	 *
	 * @param int     $field_id
	 * @param string  $name
	 * @param array   $values
	 */
	public static function common_checkbox( $field_id, $name, $values = array() ) {
		$selected_name = sprintf( '%s[%d][selected]', 'fes_input', $field_id );
		$input_name = sprintf( '%s[%d][%s]', 'fes_input', $field_id, $name );

		$selected_value = ( $values && isset( $values['selected'] ) ) ? $values['selected'] : array();
		$add = fes_assets_url .'img/add.png';
		$remove = fes_assets_url. 'img/remove.png';

		if ( $values && $values['options'] > 0 ) {
			foreach ( $values['options'] as $key => $value ) { ?>
				<div>
					<input type="checkbox" name="<?php echo $selected_name ?>[]" value="<?php echo $value; ?>"<?php echo in_array( $value, $selected_value ) ? ' checked="checked"' : ''; ?> />
					<input type="text" name="<?php echo $input_name; ?>[]" value="<?php echo $value; ?>">
					<img style="cursor:pointer; margin:0 3px;" alt="add another choice" title="add another choice" class="fes-clone-field" src="<?php echo $add; ?>">
					<img style="cursor:pointer;" class="fes-remove-field" alt="remove this choice" title="remove this choice" src="<?php echo $remove; ?>">
				</div>
				<?php
			}
		} else { ?>
			<div>
				<input type="checkbox" name="<?php echo $selected_name ?>[]">
				<input type="text" name="<?php echo $input_name; ?>[]" value="">
				<img style="cursor:pointer; margin:0 3px;" alt="add another choice" title="add another choice" class="fes-clone-field" src="<?php echo $add; ?>">
				<img style="cursor:pointer;" class="fes-remove-field" alt="remove this choice" title="remove this choice" src="<?php echo $remove; ?>">
			</div>
		<?php
		}
	}

	/**
	 * Show field on the frontend?
	 *
	 * @param int     $inex
	 * @param string  $name
	 * @param array   $characteristics
	 */
	public static function field_div( $index, $name, $characteristics, $insert = false ) {
		$open_by_default = apply_filters( 'fes_formbuilder_fields_open_by_default', false );
		if ( $insert || $open_by_default ){
			?><div class="fes-form-holder"><?php
		} else {
			?><div class="fes-form-holder" style="display: none;"><?php
		}
	}

	/**
	 * Show field on the frontend?
	 *
	 * @param int     $id
	 * @param array   $values
	 */
	public static function public_radio( $id, $values = array(), $name = 'login', $hidden = false ) {
		if ( $name !== 'submission' ) { // todo for FES 2.4 && $name !== 'profile' ){
			return;
		}
		$tpl = '%s[%d][%s]';
		$field_name  = sprintf( $tpl, 'fes_input', $id, 'public' );
		$field_value = $values && isset( $values[ 'public' ] ) ? esc_attr( $values[ 'public' ] ) : false;
		if ( $field_value == 'on' ) {
			$field_value = true;
		}
		if ( $hidden ) { ?>
			<div class="fes-form-rows">
				<input type="hidden" id="<?php echo esc_attr( $field_name ); ?>" name="<?php echo esc_attr( $field_name ); ?>" <?php checked( $field_value, true ); ?> />
			</div>
			<?php
		} else { ?>
			<div class="fes-form-rows">
				<label><?php _e( 'Allow this field to be shown publicly', 'edd_fes' ); ?></label>
				<div class="fes-form-sub-fields">
					<label for="<?php esc_attr_e( $field_name ); ?>">
						<input type="checkbox" data-type="label" id="<?php echo esc_attr( $field_name ); ?>" name="<?php echo esc_attr( $field_name ); ?>" class="smallipopInput" <?php checked( $field_value, true ); ?>>
						<?php _e( 'Allows widgets to output data from this field, as well as shows this field\'s value when the FES setting Show Custom Meta is on.', 'edd_fes' ); ?>
					</label>
				</div>
			</div>
			<?php
		}
	}
}
